window.onload = initForms;

function initForms() {
     for (var i=0; i< document.forms.length; i++) {
         document.forms[i].onsubmit = function() {return validForm();}
     }
}

function validForm() {
     var error_string = "";
     var allGood = true;
     var allTags = document.getElementsByTagName ("*");

     for (var i=0; i<allTags.length; i++) {
        if (!validTag(allTags[i])) {
           allGood = false;
        }
     }

if (!allGood) {

error_string = "    ... \n" + error_string;
alert(error_string);
}

     return allGood;

     function validTag(thisTag) {
        var outClass = "";
        var allClasses = thisTag.className.split (" ");

        for (var j=0; j<allClasses.length; j++) {
           outClass += validBasedOnClass(allClasses[j]) + " ";
        }

        thisTag.className = outClass;
        if (outClass.indexOf("invalid") > -1) {
           invalidLabel(thisTag.parentNode);
           thisTag.focus();
           if (thisTag.nodeName == "INPUT") {
              thisTag.select();
           }
           return false;
        }
        return true;

        function validBasedOnClass(thisClass) {
           var classBack = "";

           switch(thisClass) {
              case "":
              case "invalid":
                 break;
              case "reqd":
                 if (allGood && thisTag.value == "") classBack = "invalid ";
                 classBack += thisClass;
                 break;

              case "email":
                 if (allGood && !validEmail (thisTag.value)) classBack = "invalid ";
                 classBack += thisClass;
                 break;


              default:
                 if (allGood && !crossCheck (thisTag,thisClass)) classBack = "invalid ";
                 classBack += thisClass;
           }
           return classBack;
        }

        function crossCheck(inTag,otherFieldID) {
           if (!document.getElementById (otherFieldID)) return false;
//           error_string += "  / .\n";
           return (inTag.value != "" ||  document.getElementById (otherFieldID).value != "");
        }


        function validEmail(email) {
           var invalidChars = " /:,;";
           var error_string_email = "";
           var badcharwas = 0;

           if (email == "") {
              error_string_email += " .\n";
           }

           for (var k=0; k<invalidChars.length; k++) {
              var badChar = invalidChars. charAt(k);
              if ((email.indexOf(badChar) > -1) && (badcharwas != 1)) {
              error_string_email += "    .\n";
              badcharwas = 1;
              }

           }
           var atPos = email.indexOf("@",1);
           if (atPos == -1) {
              error_string_email += "      @.\n";
           }
           if (email.indexOf("@",atPos+1) != -1) {
              error_string_email += "   @    .\n";
           }
           var periodPos = email.indexOf(".",atPos);
           if (periodPos == -1) {
             error_string_email += "    ''.\n";
           }
           if (periodPos+3 > email.length) {
            error_string_email += "   .\n";
           }

           if (error_string_email == "")
           {return true;} 
           else {
           alert(error_string_email);
           return false;
           }
        }


        function invalidLabel(parentTag) {
           if (parentTag.nodeName == "LABEL") {
              parentTag.className += " invalid";
           }
        }
     }
}


